<template>
  <div>
    <h2>Posts page</h2>
    <my-input v-model="searchQuery" placeholder="Search..." class="search"/>
    <div class="app__btns">
      <my-button
        @click="showDialog"
      >
        Create post
      </my-button>
      <my-select
        v-model="selectedSort"
        :options="sortOptions"
      />
    </div>
    <my-dialog v-model:show="dialogVisible">
      <post-form @create="createPost"/>
    </my-dialog>
    <post-list
        :posts="sortedAndSearchedPosts"
        @remove="removePost"
        v-if="!isPostsLoading"
    />
    <div v-else>Loading...</div>
    <div v-intersection="loadMorePosts" class="observer"></div>
<!--    <pagination :total-pages="totalPages" v-model:current-page="page" @fetch-posts="fetchPosts"/>-->
  </div>
</template>

<script>
import PostForm from "@/components/PostForm";
import PostList from "@/components/PostList";
import MySelect from "@/components/UI/MySelect";
import { api } from "@/axios-api";

export default {
  components: { PostList, PostForm, MySelect },

  data() {
    return {
      page: 1,
      pageLimit: 10,
      totalPages: 0,
      posts: [],
      dialogVisible: false,
      isPostsLoading: false,
      selectedSort: "",
      searchQuery: "",
      sortOptions: [
        {value: "title", name: "By name"},
        {value: "body", name: "By body"}
      ]
    };
  },
  mounted() {
    this.fetchPosts();
  },
  watch: {
    /**
     * Watcher -> if "data:page" changes, load new posts
     */
  //   page() {
  //     this.fetchPosts()
  //   }
  },
  computed: {
    sortedPosts() {
      return [...this.posts].sort((post, nextPost) => post[this.selectedSort]?.localeCompare(nextPost[this.selectedSort]))
    },
    sortedAndSearchedPosts() {
      return this.sortedPosts.filter((post) => post.title.toLowerCase().includes(this.searchQuery.toLowerCase()))
    }
  },
  methods: {
    createPost(post) {
      this.posts.push(post);
      this.dialogVisible = false;
    },
    removePost(post){
      this.posts = this.posts.filter(p => p.id !== post.id);
    },
    showDialog() {
      this.dialogVisible = true;
    },
    async fetchPosts() {
      try {
        this.isPostsLoading = true;
        const response = await api.get('posts', {
          params: {
            _page: this.page,
            _limit: this.pageLimit
          }
        });
        this.totalPages = Math.ceil(response.headers['x-total-count'] / this.pageLimit)
        this.posts = response.data;
      } catch (e) {
        alert('!Error')
      } finally {
        this.isPostsLoading = false;
      }
    },
    async loadMorePosts() {
      try {
        this.page++;
        const response = await api.get('posts', {
          params: {
            _page: this.page,
            _limit: this.pageLimit
          }
        });
        this.totalPages = Math.ceil(response.headers['x-total-count'] / this.pageLimit)
        this.posts = [...this.posts, ...response.data];
      } catch (e) {
        alert('!Error')
      }
    }
  }
}
</script>

<style scoped>
.app__btns {
  display: flex;
  justify-content: space-between;
  margin: 15px 0;
}
.search {
  width: 100%;
}
</style>
